% M106 Winter 2019, Data-driven UQ
% by Yoonsang Lee (yoonsang.lee@dartmouth.edu)
%
% Lecture 8: Importance Sampling
%
% Compare different coding styles of counting for empirical distributions
% 
% Last update: Jan 18, 2019

clear all

n=500000;

x=randn(n,1);

%% A typical method
% counting using 'if'
c1 = 0;
tic;
for i = 1:n
    if (x(i)>0.5)
        c1 = c1 + 1;
    end
    
end
disp(c1/n)
disp('computation time using the standard method')
toc; % print the computation time


%% A faster method
% counting using vector programming
tic;
c2=sum(x>0.5);
disp(c2/n)
disp('computation time using the vector programming method')
toc; % print the computation time